Index: pplinux/linuxnew/drivers/isdn/hisax/hfc_pci.c
diff -u pplinux/linuxnew/drivers/isdn/hisax/hfc_pci.c:1.1.323.1 pplinux/linuxnew/drivers/isdn/hisax/hfc_pci.c:1.2
--- pplinux/linuxnew/drivers/isdn/hisax/hfc_pci.c:1.1.323.1	Thu Feb  3 10:00:50 2005
+++ pplinux/linuxnew/drivers/isdn/hisax/hfc_pci.c	Thu Feb  3 11:35:38 2005
@@ -24,6 +24,33 @@
 #include <linux/pci.h>
 #include <linux/interrupt.h>
 
+#include <asm/ppc405_pcimcs.h>
+
+#ifdef CONFIG_PEPPERCON
+
+#define DEBUG
+#ifdef DEBUG
+# define DBG(fmt, args...)	{ printk(fmt, ##args); }
+#else
+# define DBG(fmt, args...)	{ }
+#endif
+
+#include <asm/io.h>
+#include <asm/uaccess.h>
+
+#define PPC405_PCI_BRIDGE_REGS_ADDR	((u32)0xEF400000)
+#define PPC405_PCI_BRIDGE_REGS_SIZE	((size_t)0x40)
+#define PPC_PCI_SLOT                    0
+#define PPC_PCI_FUNC                    0
+#define HFC_PCI_SLOT                    8
+#define HFC_PCI_FUNC                    0
+#define HFC_ADDR			((u32)0x90000000)
+#define HFC_SIZE			((size_t)0x00001000)
+#define HFC_REGS_SIZE			((size_t)0x00000100)
+#define HFC_IRQ				29
+
+#endif /* CONFIG_PEPPERCON */
+
 extern const char *CardType[];
 
 static const char *hfcpci_revision = "$Revision: 1.1.4.1 $";
@@ -68,6 +95,34 @@
 
 #if CONFIG_PCI
 
+#ifdef CONFIG_PEPPERCON
+
+void
+Write_hfc(struct IsdnCardState * cs, u_int offset, u8 data)
+{
+    int err;
+
+    writeb(data, ((u_char *)cs->hw.hfcpci.pci_io) + offset);
+    /*
+     * This is neccessary on ppc405 to flush the write on the PCI bus.
+     * --> no harm on other architectures
+     */
+    readb(((u_char *)cs->hw.hfcpci.pci_io) + HFCPCI_CHIP_ID);
+}
+
+u8
+Read_hfc(struct IsdnCardState * cs, u_int offset)
+{
+    u8 data;
+    int err;
+
+    data = readb(((u_char *)cs->hw.hfcpci.pci_io) + offset);
+
+    return data;
+}
+
+#endif /* CONFIG_PEPPERCON */
+
 /******************************************/
 /* free hardware resources used by driver */
 /******************************************/
@@ -88,11 +143,27 @@
 	set_current_state(TASK_UNINTERRUPTIBLE);
 	schedule_timeout((30 * HZ) / 1000);	/* Timeout 30ms */
 	Write_hfc(cs, HFCPCI_CIRM, 0);	/* Reset Off */
-	pcibios_write_config_word(cs->hw.hfcpci.pci_bus, cs->hw.hfcpci.pci_device_fn, PCI_COMMAND, 0);	/* disable memory mapped ports + busmaster */
+	/* disable memory mapped ports + busmaster */
+	mcs_pci_write_config_word(cs->hw.hfcpci.pci_dev, PCI_COMMAND, 0);
 	del_timer(&cs->hw.hfcpci.timer);
+#ifdef CONFIG_PEPPERCON
+	/* clear signature and free communication buffer */
+	if (cs->hw.hfcpci.share_start) {
+		pci_free_consistent(NULL, 32768, cs->hw.hfcpci.share_start,
+				    cs->hw.hfcpci.fifo_bus_addr);
+	}
+#else
 	kfree(cs->hw.hfcpci.share_start);
+#endif
 	cs->hw.hfcpci.share_start = NULL;
-	iounmap((void *)cs->hw.hfcpci.pci_io);
+
+	if (cs->hw.hfcpci.pci_io) {
+		iounmap((void *)cs->hw.hfcpci.pci_io);
+	}
+
+	if (cs->hw.hfcpci.ppc405_pci_bridge_regs) {
+		iounmap((void *)cs->hw.hfcpci.ppc405_pci_bridge_regs);
+	}
 }
 
 /********************************************************************************/
@@ -106,12 +177,16 @@
 
 	save_flags(flags);
 	cli();
-	pcibios_write_config_word(cs->hw.hfcpci.pci_bus, cs->hw.hfcpci.pci_device_fn, PCI_COMMAND, PCI_ENA_MEMIO);	/* enable memory mapped ports, disable busmaster */
+	/* enable memory mapped ports, disable busmaster */
+	mcs_pci_write_config_word(cs->hw.hfcpci.pci_dev,
+				  PCI_COMMAND, PCI_ENA_MEMIO);
 	cs->hw.hfcpci.int_m2 = 0;	/* interrupt output off ! */
 	Write_hfc(cs, HFCPCI_INT_M2, cs->hw.hfcpci.int_m2);
 
-	printk(KERN_INFO "HFC_PCI: resetting card\n");
-	pcibios_write_config_word(cs->hw.hfcpci.pci_bus, cs->hw.hfcpci.pci_device_fn, PCI_COMMAND, PCI_ENA_MEMIO + PCI_ENA_MASTER);	/* enable memory ports + busmaster */
+	printk(KERN_INFO "HFC_PCI: soft resetting chip\n");
+	/* enable memory ports + busmaster */
+	mcs_pci_write_config_word(cs->hw.hfcpci.pci_dev,
+				  PCI_COMMAND, PCI_ENA_MEMIO | PCI_ENA_MASTER);
 	Write_hfc(cs, HFCPCI_CIRM, HFCPCI_RESET);	/* Reset On */
 	sti();
 	set_current_state(TASK_UNINTERRUPTIBLE);
@@ -244,7 +319,7 @@
 	        cs->hw.hfcpci.fifo_en ^= fifo_state;
 	Write_hfc(cs, HFCPCI_FIFO_EN, cs->hw.hfcpci.fifo_en);
 	cs->hw.hfcpci.last_bfifo_cnt[fifo] = 0;
-	bzr->za[MAX_B_FRAMES].z1 = B_FIFO_SIZE + B_SUB_VAL - 1;
+	bzr->za[MAX_B_FRAMES].z1 = cpu_to_le16(B_FIFO_SIZE + B_SUB_VAL - 1);
 	bzr->za[MAX_B_FRAMES].z2 = bzr->za[MAX_B_FRAMES].z1;
 	bzr->f1 = MAX_B_FRAMES;
 	bzr->f2 = bzr->f1;	/* init F pointers to remain constant */
@@ -270,7 +345,7 @@
 	if (fifo_state)
 	        cs->hw.hfcpci.fifo_en ^= fifo_state;
 	Write_hfc(cs, HFCPCI_FIFO_EN, cs->hw.hfcpci.fifo_en);
-	bzt->za[MAX_B_FRAMES].z1 = B_FIFO_SIZE + B_SUB_VAL - 1;
+	bzt->za[MAX_B_FRAMES].z1 = cpu_to_le16(B_FIFO_SIZE + B_SUB_VAL - 1);
 	bzt->za[MAX_B_FRAMES].z2 = bzt->za[MAX_B_FRAMES].z1;
 	bzt->f1 = MAX_B_FRAMES;
 	bzt->f2 = bzt->f1;	/* init F pointers to remain constant */
@@ -298,18 +373,18 @@
 	if ((cs->debug & L1_DEB_HSCX) && !(cs->debug & L1_DEB_HSCX_FIFO))
 		debugl1(cs, "hfcpci_empty_fifo");
 	zp = &bz->za[bz->f2];	/* point to Z-Regs */
-	new_z2 = zp->z2 + count;	/* new position in fifo */
+	new_z2 = le16_to_cpu(zp->z2) + count;	/* new position in fifo */
 	if (new_z2 >= (B_FIFO_SIZE + B_SUB_VAL))
 		new_z2 -= B_FIFO_SIZE;	/* buffer wrap */
 	new_f2 = (bz->f2 + 1) & MAX_B_FRAMES;
 	if ((count > HSCX_BUFMAX + 3) || (count < 4) ||
-	    (*(bdata + (zp->z1 - B_SUB_VAL)))) {
+	    (*(bdata + (le16_to_cpu(zp->z1) - B_SUB_VAL)))) {
 		if (cs->debug & L1_DEB_WARN)
 			debugl1(cs, "hfcpci_empty_fifo: incoming packet invalid length %d or crc", count);
 #ifdef ERROR_STATISTIC
 		bcs->err_inv++;
 #endif
-		bz->za[new_f2].z2 = new_z2;
+		bz->za[new_f2].z2 = cpu_to_le16(new_z2);
 		bz->f2 = new_f2;	/* next buffer */
 		skb = NULL;
 	} else if (!(skb = dev_alloc_skb(count - 3)))
@@ -319,12 +394,12 @@
 		count -= 3;
 		ptr = skb_put(skb, count);
 
-		if (zp->z2 + count <= B_FIFO_SIZE + B_SUB_VAL)
+		if (le16_to_cpu(zp->z2) + count <= B_FIFO_SIZE + B_SUB_VAL)
 			maxlen = count;		/* complete transfer */
 		else
-			maxlen = B_FIFO_SIZE + B_SUB_VAL - zp->z2;	/* maximum */
+			maxlen = B_FIFO_SIZE + B_SUB_VAL - le16_to_cpu(zp->z2);	/* maximum */
 
-		ptr1 = bdata + (zp->z2 - B_SUB_VAL);	/* start of data */
+		ptr1 = bdata + (le16_to_cpu(zp->z2) - B_SUB_VAL);	/* start of data */
 		memcpy(ptr, ptr1, maxlen);	/* copy data */
 		count -= maxlen;
 
@@ -333,7 +408,7 @@
 			ptr1 = bdata;	/* start of buffer */
 			memcpy(ptr, ptr1, count);	/* rest */
 		}
-		bz->za[new_f2].z2 = new_z2;
+		bz->za[new_f2].z2 = cpu_to_le16(new_z2);
 		bz->f2 = new_f2;	/* next buffer */
 
 	}
@@ -363,34 +438,34 @@
 	}
 	while (((df->f1 & D_FREG_MASK) != (df->f2 & D_FREG_MASK)) && count--) {
 		zp = &df->za[df->f2 & D_FREG_MASK];
-		rcnt = zp->z1 - zp->z2;
+		rcnt = le16_to_cpu(zp->z1) - le16_to_cpu(zp->z2);
 		if (rcnt < 0)
 			rcnt += D_FIFO_SIZE;
 		rcnt++;
 		if (cs->debug & L1_DEB_ISAC)
 			debugl1(cs, "hfcpci recd f1(%d) f2(%d) z1(%x) z2(%x) cnt(%d)",
-				df->f1, df->f2, zp->z1, zp->z2, rcnt);
+				df->f1, df->f2, le16_to_cpu(zp->z1), le16_to_cpu(zp->z2), rcnt);
 
 		if ((rcnt > MAX_DFRAME_LEN + 3) || (rcnt < 4) ||
-		    (df->data[zp->z1])) {
+		    (df->data[le16_to_cpu(zp->z1)])) {
 			if (cs->debug & L1_DEB_WARN)
-				debugl1(cs, "empty_fifo hfcpci paket inv. len %d or crc %d", rcnt, df->data[zp->z1]);
+				debugl1(cs, "empty_fifo hfcpci paket inv. len %d or crc %d", rcnt, df->data[le16_to_cpu(zp->z1)]);
 #ifdef ERROR_STATISTIC
 			cs->err_rx++;
 #endif
 			df->f2 = ((df->f2 + 1) & MAX_D_FRAMES) | (MAX_D_FRAMES + 1);	/* next buffer */
-			df->za[df->f2 & D_FREG_MASK].z2 = (zp->z2 + rcnt) & (D_FIFO_SIZE - 1);
+			df->za[df->f2 & D_FREG_MASK].z2 = cpu_to_le16((le16_to_cpu(zp->z2) + rcnt) & (D_FIFO_SIZE - 1));
 		} else if ((skb = dev_alloc_skb(rcnt - 3))) {
 			total = rcnt;
 			rcnt -= 3;
 			ptr = skb_put(skb, rcnt);
 
-			if (zp->z2 + rcnt <= D_FIFO_SIZE)
+			if (le16_to_cpu(zp->z2) + rcnt <= D_FIFO_SIZE)
 				maxlen = rcnt;	/* complete transfer */
 			else
-				maxlen = D_FIFO_SIZE - zp->z2;	/* maximum */
+				maxlen = D_FIFO_SIZE - le16_to_cpu(zp->z2);	/* maximum */
 
-			ptr1 = df->data + zp->z2;	/* start of data */
+			ptr1 = df->data + le16_to_cpu(zp->z2);	/* start of data */
 			memcpy(ptr, ptr1, maxlen);	/* copy data */
 			rcnt -= maxlen;
 
@@ -400,7 +475,7 @@
 				memcpy(ptr, ptr1, rcnt);	/* rest */
 			}
 			df->f2 = ((df->f2 + 1) & MAX_D_FRAMES) | (MAX_D_FRAMES + 1);	/* next buffer */
-			df->za[df->f2 & D_FREG_MASK].z2 = (zp->z2 + total) & (D_FIFO_SIZE - 1);
+			df->za[df->f2 & D_FREG_MASK].z2 = cpu_to_le16((le16_to_cpu(zp->z2) + total) & (D_FIFO_SIZE - 1));
 
 			skb_queue_tail(&cs->rq, skb);
 			sched_event_D_pci(cs, D_RCVBUFREADY);
@@ -425,7 +500,7 @@
 	z1r = &bz->za[MAX_B_FRAMES].z1;		/* pointer to z reg */
 	z2r = z1r + 1;
 
-	if (!(fcnt = *z1r - *z2r))
+	if (!(fcnt = le16_to_cpu(*z1r) - le16_to_cpu(*z2r)))
 		return (0);	/* no data avail */
 
 	if (fcnt <= 0)
@@ -433,7 +508,7 @@
 	if (fcnt > HFCPCI_BTRANS_THRESHOLD)
 		fcnt = HFCPCI_BTRANS_THRESHOLD;		/* limit size */
 
-	new_z2 = *z2r + fcnt;	/* new position in fifo */
+	new_z2 = le16_to_cpu(*z2r) + fcnt;	/* new position in fifo */
 	if (new_z2 >= (B_FIFO_SIZE + B_SUB_VAL))
 		new_z2 -= B_FIFO_SIZE;	/* buffer wrap */
 
@@ -441,12 +516,12 @@
 		printk(KERN_WARNING "HFCPCI: receive out of memory\n");
 	else {
 		ptr = skb_put(skb, fcnt);
-		if (*z2r + fcnt <= B_FIFO_SIZE + B_SUB_VAL)
+		if (le16_to_cpu(*z2r) + fcnt <= B_FIFO_SIZE + B_SUB_VAL)
 			maxlen = fcnt;	/* complete transfer */
 		else
-			maxlen = B_FIFO_SIZE + B_SUB_VAL - *z2r;	/* maximum */
+			maxlen = B_FIFO_SIZE + B_SUB_VAL - le16_to_cpu(*z2r);	/* maximum */
 
-		ptr1 = bdata + (*z2r - B_SUB_VAL);	/* start of data */
+		ptr1 = bdata + (le16_to_cpu(*z2r) - B_SUB_VAL);	/* start of data */
 		memcpy(ptr, ptr1, maxlen);	/* copy data */
 		fcnt -= maxlen;
 
@@ -461,7 +536,7 @@
 		hfcpci_sched_event(bcs, B_RCVBUFREADY);
 	}
 
-	*z2r = new_z2;		/* new position */
+	*z2r = cpu_to_le16(new_z2);		/* new position */
 	return (1);
 }				/* hfcpci_empty_fifo_trans */
 
@@ -506,13 +581,13 @@
 				bcs->channel, bz->f1, bz->f2);
 		zp = &bz->za[bz->f2];
 
-		rcnt = zp->z1 - zp->z2;
+		rcnt = le16_to_cpu(zp->z1) - le16_to_cpu(zp->z2);
 		if (rcnt < 0)
 			rcnt += B_FIFO_SIZE;
 		rcnt++;
 		if (cs->debug & L1_DEB_HSCX)
 			debugl1(cs, "hfcpci rec %d z1(%x) z2(%x) cnt(%d)",
-				bcs->channel, zp->z1, zp->z2, rcnt);
+				bcs->channel, le16_to_cpu(zp->z1), le16_to_cpu(zp->z2), rcnt);
 		if ((skb = hfcpci_empty_fifo(bcs, bz, bdata, rcnt))) {
 			cli();
 			skb_queue_tail(&bcs->rqueue, skb);
@@ -564,7 +639,7 @@
 	if (cs->debug & L1_DEB_ISAC)
 		debugl1(cs, "hfcpci_fill_Dfifo f1(%d) f2(%d) z1(f1)(%x)",
 			df->f1, df->f2,
-			df->za[df->f1 & D_FREG_MASK].z1);
+			le16_to_cpu(df->za[df->f1 & D_FREG_MASK].z1));
 	fcnt = df->f1 - df->f2;	/* frame count actually buffered */
 	if (fcnt < 0)
 		fcnt += (MAX_D_FRAMES + 1);	/* if wrap around */
@@ -577,7 +652,7 @@
 		return;
 	}
 	/* now determine free bytes in FIFO buffer */
-	count = df->za[df->f1 & D_FREG_MASK].z2 - df->za[df->f1 & D_FREG_MASK].z1;
+	count = le16_to_cpu(df->za[df->f1 & D_FREG_MASK].z2) - le16_to_cpu(df->za[df->f1 & D_FREG_MASK].z1);
 	if (count <= 0)
 		count += D_FIFO_SIZE;	/* count now contains available bytes */
 
@@ -590,11 +665,11 @@
 		return;
 	}
 	count = cs->tx_skb->len;	/* get frame len */
-	new_z1 = (df->za[df->f1 & D_FREG_MASK].z1 + count) & (D_FIFO_SIZE - 1);
+	new_z1 = (le16_to_cpu(df->za[df->f1 & D_FREG_MASK].z1) + count) & (D_FIFO_SIZE - 1);
 	new_f1 = ((df->f1 + 1) & D_FREG_MASK) | (D_FREG_MASK + 1);
 	src = cs->tx_skb->data;	/* source pointer */
-	dst = df->data + df->za[df->f1 & D_FREG_MASK].z1;
-	maxlen = D_FIFO_SIZE - df->za[df->f1 & D_FREG_MASK].z1;		/* end fifo */
+	dst = df->data + le16_to_cpu(df->za[df->f1 & D_FREG_MASK].z1);
+	maxlen = D_FIFO_SIZE - le16_to_cpu(df->za[df->f1 & D_FREG_MASK].z1);		/* end fifo */
 	if (maxlen > count)
 		maxlen = count;	/* limit size */
 	memcpy(dst, src, maxlen);	/* first copy */
@@ -607,8 +682,8 @@
 	}
 	save_flags(flags);
 	cli();
-	df->za[new_f1 & D_FREG_MASK].z1 = new_z1;	/* for next buffer */
-	df->za[df->f1 & D_FREG_MASK].z1 = new_z1;	/* new pos actual buffer */
+	df->za[new_f1 & D_FREG_MASK].z1 = cpu_to_le16(new_z1);	/* for next buffer */
+	df->za[df->f1 & D_FREG_MASK].z1 = cpu_to_le16(new_z1);	/* new pos actual buffer */
 	df->f1 = new_f1;	/* next frame */
 	restore_flags(flags);
 
@@ -653,8 +728,8 @@
 		z2t = z1t + 1;
 		if (cs->debug & L1_DEB_HSCX)
 			debugl1(cs, "hfcpci_fill_fifo_trans %d z1(%x) z2(%x)",
-				bcs->channel, *z1t, *z2t);
-		fcnt = *z2t - *z1t;
+				bcs->channel, le16_to_cpu(*z1t), le16_to_cpu(*z2t));
+		fcnt = le16_to_cpu(*z2t) - le16_to_cpu(*z1t);
 		if (fcnt <= 0)
 			fcnt += B_FIFO_SIZE;	/* fcnt contains available bytes in fifo */
 		fcnt = B_FIFO_SIZE - fcnt;	/* remaining bytes to send */
@@ -664,12 +739,12 @@
 				/* data is suitable for fifo */
 				count = bcs->tx_skb->len;
 
-				new_z1 = *z1t + count;	/* new buffer Position */
+				new_z1 = le16_to_cpu(*z1t) + count;	/* new buffer Position */
 				if (new_z1 >= (B_FIFO_SIZE + B_SUB_VAL))
 					new_z1 -= B_FIFO_SIZE;	/* buffer wrap */
 				src = bcs->tx_skb->data;	/* source pointer */
-				dst = bdata + (*z1t - B_SUB_VAL);
-				maxlen = (B_FIFO_SIZE + B_SUB_VAL) - *z1t;	/* end of fifo */
+				dst = bdata + (le16_to_cpu(*z1t) - B_SUB_VAL);
+				maxlen = (B_FIFO_SIZE + B_SUB_VAL) - le16_to_cpu(*z1t);	/* end of fifo */
 				if (maxlen > count)
 					maxlen = count;		/* limit size */
 				memcpy(dst, src, maxlen);	/* first copy */
@@ -682,7 +757,7 @@
 				}
 				bcs->tx_cnt -= bcs->tx_skb->len;
 				fcnt += bcs->tx_skb->len;
-				*z1t = new_z1;	/* now send data */
+				*z1t = cpu_to_le16(new_z1);	/* now send data */
 			} else if (cs->debug & L1_DEB_HSCX)
 				debugl1(cs, "hfcpci_fill_fifo_trans %d frame length %d discarded",
 					bcs->channel, bcs->tx_skb->len);
@@ -703,7 +778,7 @@
 	if (cs->debug & L1_DEB_HSCX)
 		debugl1(cs, "hfcpci_fill_fifo_hdlc %d f1(%d) f2(%d) z1(f1)(%x)",
 			bcs->channel, bz->f1, bz->f2,
-			bz->za[bz->f1].z1);
+			le16_to_cpu(bz->za[bz->f1].z1));
 
 	fcnt = bz->f1 - bz->f2;	/* frame count actually buffered */
 	if (fcnt < 0)
@@ -715,7 +790,7 @@
 		return;
 	}
 	/* now determine free bytes in FIFO buffer */
-	count = bz->za[bz->f1].z2 - bz->za[bz->f1].z1;
+	count = le16_to_cpu(bz->za[bz->f1].z2) - le16_to_cpu(bz->za[bz->f1].z1);
 	if (count <= 0)
 		count += B_FIFO_SIZE;	/* count now contains available bytes */
 
@@ -731,14 +806,14 @@
 		return;
 	}
 	count = bcs->tx_skb->len;	/* get frame len */
-	new_z1 = bz->za[bz->f1].z1 + count;	/* new buffer Position */
+	new_z1 = le16_to_cpu(bz->za[bz->f1].z1) + count;	/* new buffer Position */
 	if (new_z1 >= (B_FIFO_SIZE + B_SUB_VAL))
 		new_z1 -= B_FIFO_SIZE;	/* buffer wrap */
 
 	new_f1 = ((bz->f1 + 1) & MAX_B_FRAMES);
 	src = bcs->tx_skb->data;	/* source pointer */
-	dst = bdata + (bz->za[bz->f1].z1 - B_SUB_VAL);
-	maxlen = (B_FIFO_SIZE + B_SUB_VAL) - bz->za[bz->f1].z1;		/* end fifo */
+	dst = bdata + (le16_to_cpu(bz->za[bz->f1].z1) - B_SUB_VAL);
+	maxlen = (B_FIFO_SIZE + B_SUB_VAL) - le16_to_cpu(bz->za[bz->f1].z1);		/* end fifo */
 	if (maxlen > count)
 		maxlen = count;	/* limit size */
 	memcpy(dst, src, maxlen);	/* first copy */
@@ -755,7 +830,7 @@
 		bcs->st->lli.l1writewakeup(bcs->st, bcs->tx_skb->len);
 
 	cli();
-	bz->za[new_f1].z1 = new_z1;	/* for next buffer */
+	bz->za[new_f1].z1 = cpu_to_le16(new_z1);	/* for next buffer */
 	bz->f1 = new_f1;	/* next frame */
 	restore_flags(flags);
 
@@ -896,34 +971,34 @@
 				bz->f1, bz->f2);
 		zp = &bz->za[bz->f2];
 
-		rcnt = zp->z1 - zp->z2;
+		rcnt = le16_to_cpu(zp->z1) - le16_to_cpu(zp->z2);
 		if (rcnt < 0)
 			rcnt += B_FIFO_SIZE;
 		rcnt++;
 		if (cs->debug & L1_DEB_ISAC)
 			debugl1(cs, "hfcpci e_rec z1(%x) z2(%x) cnt(%d)",
-				zp->z1, zp->z2, rcnt);
-		new_z2 = zp->z2 + rcnt;		/* new position in fifo */
+				le16_to_cpu(zp->z1), le16_to_cpu(zp->z2), rcnt);
+		new_z2 = le16_to_cpu(zp->z2) + rcnt;		/* new position in fifo */
 		if (new_z2 >= (B_FIFO_SIZE + B_SUB_VAL))
 			new_z2 -= B_FIFO_SIZE;	/* buffer wrap */
 		new_f2 = (bz->f2 + 1) & MAX_B_FRAMES;
 		if ((rcnt > 256 + 3) || (count < 4) ||
-		    (*(bdata + (zp->z1 - B_SUB_VAL)))) {
+		    (*(bdata + (le16_to_cpu(zp->z1) - B_SUB_VAL)))) {
 			if (cs->debug & L1_DEB_WARN)
 				debugl1(cs, "hfcpci_empty_echan: incoming packet invalid length %d or crc", rcnt);
-			bz->za[new_f2].z2 = new_z2;
+			bz->za[new_f2].z2 = cpu_to_le16(new_z2);
 			bz->f2 = new_f2;	/* next buffer */
 		} else {
 			total = rcnt;
 			rcnt -= 3;
 			ptr = e_buffer;
 
-			if (zp->z2 <= B_FIFO_SIZE + B_SUB_VAL)
+			if (le16_to_cpu(zp->z2) <= B_FIFO_SIZE + B_SUB_VAL)
 				maxlen = rcnt;	/* complete transfer */
 			else
-				maxlen = B_FIFO_SIZE + B_SUB_VAL - zp->z2;	/* maximum */
+				maxlen = B_FIFO_SIZE + B_SUB_VAL - le16_to_cpu(zp->z2);	/* maximum */
 
-			ptr1 = bdata + (zp->z2 - B_SUB_VAL);	/* start of data */
+			ptr1 = bdata + (le16_to_cpu(zp->z2) - B_SUB_VAL);	/* start of data */
 			memcpy(ptr, ptr1, maxlen);	/* copy data */
 			rcnt -= maxlen;
 
@@ -932,7 +1007,7 @@
 				ptr1 = bdata;	/* start of buffer */
 				memcpy(ptr, ptr1, rcnt);	/* rest */
 			}
-			bz->za[new_f2].z2 = new_z2;
+			bz->za[new_f2].z2 = cpu_to_le16(new_z2);
 			bz->f2 = new_f2;	/* next buffer */
 			if (cs->debug & DEB_DLOG_HEX) {
 				ptr = cs->dlog;
@@ -1678,11 +1753,12 @@
 	return (0);
 }
 
-
+#ifndef CONFIG_PEPPERCON
 /* this variable is used as card index when more than one cards are present */
 static struct pci_dev *dev_hfcpci __initdata = NULL;
+#endif
 
-#endif				/* CONFIG_PCI */
+#endif /* CONFIG_PCI */
 
 int __init
 setup_hfcpci(struct IsdnCard *card)
@@ -1690,11 +1766,13 @@
 	struct IsdnCardState *cs = card->cs;
 	char tmp[64];
 	int i;
+#ifdef CONFIG_PEPPERCON
+	u32 val;
+	struct pci_dev * ppc_pci_dev;
+#else
 	struct pci_dev *tmp_hfcpci = NULL;
-
-#ifdef __BIG_ENDIAN
-#error "not running on big endian machines now"
 #endif
+
 	strcpy(tmp, hfcpci_revision);
 	printk(KERN_INFO "HiSax: HFC-PCI driver Rev. %s\n", HiSax_getrev(tmp));
 #if CONFIG_PCI
@@ -1702,6 +1780,148 @@
 	cs->dc.hfcpci.ph_state = 0;
 	cs->hw.hfcpci.fifo = 255;
 	if (cs->typ == ISDN_CTYPE_HFC_PCI) {
+#ifdef CONFIG_PEPPERCON
+		/* ---- find the PPC PCI device ---------------------------- */
+
+		ppc_pci_dev =
+			pci_find_slot(0, PCI_DEVFN(PPC_PCI_SLOT, PPC_PCI_FUNC));
+		if (ppc_pci_dev == NULL) {
+			printk("HFC-PCI: PPC PCI device not detected\n");
+			return 0;
+		}
+
+		/* ---- find the HFC PCI device ---------------------------- */
+
+		cs->hw.hfcpci.pci_dev =
+			pci_find_slot(0, PCI_DEVFN(HFC_PCI_SLOT, HFC_PCI_FUNC));
+		if (cs->hw.hfcpci.pci_dev == NULL) {
+			printk(KERN_WARNING "HFC-PCI: No PCI card found\n");
+			return 0;
+		}
+
+		cs->irq = HFC_IRQ;
+		printk(KERN_INFO "HiSax: HFC-PCI card manufacturer: "
+		       "%s card name: %s\n", id_list[0].vendor_name,
+		       id_list[0].card_name);
+
+		/* ---- if PPC or HFC got no PCI resources - bail out ------ */
+
+		mcs_pci_read_config_dword(ppc_pci_dev, PCI_BASE_ADDRESS_2,
+					  &val);
+
+		printk(KERN_INFO "HFC-PCI: PPC PCIBAR2 = 0x%08x\n", val);
+
+		if ((val & 0xFFFFFF00) == 0) {
+			printk(KERN_WARNING "HFC-PCI: PPC got no PCI resources\n");
+			return 0;
+		}
+
+		mcs_pci_read_config_dword(cs->hw.hfcpci.pci_dev,
+					  PCI_BASE_ADDRESS_1, &val);
+
+		printk(KERN_INFO "HFC-PCI: HFC PCIBAR1 = 0x%08x\n", val);
+
+		if ((val & 0xFFFFFF00) == 0) {
+			printk(KERN_WARNING "HFC-PCI: HFC got no PCI resources\n");
+			return 0;
+		}
+
+		/* ---- map PCI bridge registers --------------------------- */
+
+		cs->hw.hfcpci.ppc405_pci_bridge_regs =
+		       ioremap_nocache(PPC405_PCI_BRIDGE_REGS_ADDR,
+				       PPC405_PCI_BRIDGE_REGS_SIZE);
+		if (cs->hw.hfcpci.ppc405_pci_bridge_regs == NULL) {
+			printk(KERN_WARNING "HFC-PCI: failed to map PCI "
+			       "bridge registers of PPC405\n");
+			return 0;
+		}
+
+		/*
+		 * ISDN FIFO buffer allocation:
+		 *   - HFCs is PCI bus master and need pointer to 405GP memory
+		 *   - 405GP allocates 2 PCI bus ranches HOST -> 405GP memory
+		 * 	* base addresses PCIBAR1 and PCIBAR2 are in 405GP
+		 * 	  PCI CFG space offset 0x14 and 0x18
+		 * 	* these pointers are initiated from HOST during BIOS
+		 * 	  start
+		 *   - this HFC driver use pointer PCIBAR2 and write it as FIFO
+		 *     pointer to HFC PCI CFG offset 0x80
+		 *   - then the driver allocates 32kByte FIFO memory and write
+		 *     the pointer to the PCIBAR2 -> 405GP LOCALMEM mapping
+		 *     register
+		 *   - every access to the phys memory location in PCIBAR2 is
+		 *     now transfered to the allocated ISDN FIFO memory
+		 *     independent, if PCI initiator is before or behind
+		 *     PCI2PCI bridge
+		 *     Problem: 405GP PCIBAR2 and PCI2PCI bridge must
+		 *              be initialized
+		 */
+
+  		cs->hw.hfcpci.share_start = cs->hw.hfcpci.fifos =
+			pci_alloc_consistent(NULL, 32768,
+					     &cs->hw.hfcpci.fifo_bus_addr);
+  		if (cs->hw.hfcpci.share_start == NULL) {
+	  		printk(KERN_ALERT "HFC-PCI: pci_alloc_consistent "
+			       "failed\n");
+	  		return 0;
+  		}
+		DBG("HFC-PCI: fifo mem @ 0x%p (virtual) / 0x%08x (bus)\n",
+		    cs->hw.hfcpci.share_start,
+		    (u32)cs->hw.hfcpci.fifo_bus_addr);
+
+		/* write FIFO pointer to ISDN chip CFG space offset 0x80 */
+		mcs_pci_read_config_dword(ppc_pci_dev, PCI_BASE_ADDRESS_2,
+					  &val);
+		mcs_pci_write_config_dword(cs->hw.hfcpci.pci_dev, 0x80, val);
+
+		/*
+		 * map PCI memory to 405 memory; use allocated FIFO memory
+		 * for ISDN PCI bus mastering
+		 */
+		
+		writel(cs->hw.hfcpci.fifo_bus_addr,
+		       &cs->hw.hfcpci.ppc405_pci_bridge_regs[0xf]);
+		writel(0xFFFF8000 | 1,
+		       &cs->hw.hfcpci.ppc405_pci_bridge_regs[0xe]);
+
+		/* ---- map ISDN register memory into PLB space ------------ */
+
+		mcs_pci_read_config_dword(cs->hw.hfcpci.pci_dev,
+					  PCI_BASE_ADDRESS_1,
+					  &cs->hw.hfcpci.pci_io_bus);
+		if (cs->hw.hfcpci.pci_io_bus != 0 &&
+		    cs->hw.hfcpci.pci_io_bus != 0xFFFFFFFF) {
+			writel(HFC_ADDR,
+			       &cs->hw.hfcpci.ppc405_pci_bridge_regs[0x4]);
+			writel(~(HFC_SIZE - 1) | 1,
+			       &cs->hw.hfcpci.ppc405_pci_bridge_regs[0x5]);
+			writel(cs->hw.hfcpci.pci_io_bus,
+			       &cs->hw.hfcpci.ppc405_pci_bridge_regs[0x6]);
+			writel(0x00000000,
+			       &cs->hw.hfcpci.ppc405_pci_bridge_regs[0x7]);
+			cs->hw.hfcpci.pci_io_valid = 1;
+		}
+
+		/* set ISDN register pointer to PLB */
+		cs->hw.hfcpci.pci_io =
+			ioremap_nocache(HFC_ADDR +
+					(cs->hw.hfcpci.pci_io_bus & 0xFFF),
+					HFC_REGS_SIZE);
+#if 0
+		for (i = 0; i <= 0xf; i++) {
+			DBG("HFC-PCI: pci bridge reg %02x: %08x\n", i,
+			    readl(&cs->hw.hfcpci.ppc405_pci_bridge_regs[i]));
+		}
+
+		for (i = 0; i <= 0x100; i += 4) {
+			DBG("%02x ", Read_hfc(cs, i));
+			if (((i + 4) % 16) == 0) DBG("\n");
+		}
+#endif
+		
+#else /* !CONFIG_PEPPERCON */
+
 		i = 0;
 		while (id_list[i].vendor_id) {
 			tmp_hfcpci = pci_find_device(id_list[i].vendor_id,
@@ -1722,20 +1942,18 @@
 		if (tmp_hfcpci) {
 			i--;
 			dev_hfcpci = tmp_hfcpci;	/* old device */
-			cs->hw.hfcpci.pci_bus = dev_hfcpci->bus->number;
-			cs->hw.hfcpci.pci_device_fn = dev_hfcpci->devfn;
+			cs->hw.hfcpci.pci_dev = tmp_hfcpci;
 			cs->irq = dev_hfcpci->irq;
 			if (!cs->irq) {
 				printk(KERN_WARNING "HFC-PCI: No IRQ for PCI card found\n");
 				return (0);
 			}
-			cs->hw.hfcpci.pci_io = (char *) dev_hfcpci->resource[ 1].start;
 			printk(KERN_INFO "HiSax: HFC-PCI card manufacturer: %s card name: %s\n", id_list[i].vendor_name, id_list[i].card_name);
 		} else {
 			printk(KERN_WARNING "HFC-PCI: No PCI card found\n");
 			return (0);
 		}
-		if (!cs->hw.hfcpci.pci_io) {
+		if (!cs->hw.hfcpci.pci_dev->resource[1].start) {
 			printk(KERN_WARNING "HFC-PCI: No IO-Mem for PCI card found\n");
 			return (0);
 		}
@@ -1751,14 +1969,17 @@
 		pcibios_write_config_dword(cs->hw.hfcpci.pci_bus,
 				       cs->hw.hfcpci.pci_device_fn, 0x80,
 			       (u_int) virt_to_bus(cs->hw.hfcpci.fifos));
-		cs->hw.hfcpci.pci_io = ioremap((ulong) cs->hw.hfcpci.pci_io, 256);
+		cs->hw.hfcpci.pci_io = ioremap(dev_hfcpci->resource[1].start, 256);
+#endif /* !CONFIG_PEPPERCON */
 		printk(KERN_INFO
 		       "HFC-PCI: defined at mem %#x fifo %#x(%#x) IRQ %d HZ %d\n",
 		       (u_int) cs->hw.hfcpci.pci_io,
 		       (u_int) cs->hw.hfcpci.fifos,
 		       (u_int) virt_to_bus(cs->hw.hfcpci.fifos),
 		       cs->irq, HZ);
-		pcibios_write_config_word(cs->hw.hfcpci.pci_bus, cs->hw.hfcpci.pci_device_fn, PCI_COMMAND, PCI_ENA_MEMIO);	/* enable memory mapped ports, disable busmaster */
+		/* enable memory mapped ports, disable busmaster */
+		mcs_pci_write_config_word(cs->hw.hfcpci.pci_dev,
+					  PCI_COMMAND, PCI_ENA_MEMIO);
 		cs->hw.hfcpci.int_m2 = 0;	/* disable alle interrupts */
 		cs->hw.hfcpci.int_m1 = 0;
 		Write_hfc(cs, HFCPCI_INT_M1, cs->hw.hfcpci.int_m1);
Index: pplinux/linuxnew/drivers/isdn/hisax/hfc_pci.h
diff -u pplinux/linuxnew/drivers/isdn/hisax/hfc_pci.h:1.1.323.1 pplinux/linuxnew/drivers/isdn/hisax/hfc_pci.h:1.2
--- pplinux/linuxnew/drivers/isdn/hisax/hfc_pci.h:1.1.323.1	Thu Feb  3 10:00:49 2005
+++ pplinux/linuxnew/drivers/isdn/hisax/hfc_pci.h	Thu Feb  3 11:35:38 2005
@@ -227,9 +227,13 @@
     u_char fill[32768]; 
   } fifo_area;
 
-
-#define Write_hfc(a,b,c) (*(((u_char *)a->hw.hfcpci.pci_io)+b) = c) 
-#define Read_hfc(a,b) (*(((u_char *)a->hw.hfcpci.pci_io)+b))
+#ifdef CONFIG_PEPPERCON
+extern void Write_hfc(struct IsdnCardState * cs, u_int offset, u8 data);
+extern u8 Read_hfc(struct IsdnCardState * cs, u_int offset);
+#else /* !CONFIG_PEPPERCON */
+# define Write_hfc(a,b,c) (*(((u_char *)a->hw.hfcpci.pci_io)+b) = c) 
+# define Read_hfc(a,b) (*(((u_char *)a->hw.hfcpci.pci_io)+b))
+#endif /* !CONFIG_PEPPERCON */
 
 extern void main_irq_hcpci(struct BCState *bcs);
 extern void inithfcpci(struct IsdnCardState *cs);
Index: pplinux/linuxnew/drivers/isdn/hisax/hisax.h
diff -u pplinux/linuxnew/drivers/isdn/hisax/hisax.h:1.1.323.1 pplinux/linuxnew/drivers/isdn/hisax/hisax.h:1.2
--- pplinux/linuxnew/drivers/isdn/hisax/hisax.h:1.1.323.1	Thu Feb  3 10:00:50 2005
+++ pplinux/linuxnew/drivers/isdn/hisax/hisax.h	Thu Feb  3 11:35:38 2005
@@ -148,8 +148,8 @@
 #define MAX_DLOG_SPACE	2048
 #define MAX_BLOG_SPACE	256
 
-/* #define I4L_IRQ_FLAG SA_INTERRUPT */
-#define I4L_IRQ_FLAG    0
+#define I4L_IRQ_FLAG SA_INTERRUPT
+/* #define I4L_IRQ_FLAG    0 */
 
 /*
  * Statemachine
@@ -686,13 +686,19 @@
         unsigned char bswapped;
         unsigned char nt_mode;
         int nt_timer;
-	unsigned char pci_bus;
-        unsigned char pci_device_fn;
+	struct pci_dev * pci_dev;
         unsigned char *pci_io; /* start of PCI IO memory */
         void *share_start; /* shared memory for Fifos start */
         void *fifos; /* FIFO memory */ 
         int last_bfifo_cnt[2]; /* marker saving last b-fifo frame count */
 	struct timer_list timer;
+#ifdef CONFIG_PEPPERCON
+	volatile u32 * ppc405_pci_bridge_regs;
+	struct timer_list check_timer;
+	u32 pci_io_bus;
+	volatile int pci_io_valid;
+	dma_addr_t fifo_bus_addr;
+#endif /* CONFIG_PEPPERCON */
 };
 
 struct hfcSX_hw {
Index: pplinux/linuxnew/drivers/mtd/cmdlinepart.c
diff -u pplinux/linuxnew/drivers/mtd/cmdlinepart.c:1.1.323.1 pplinux/linuxnew/drivers/mtd/cmdlinepart.c:1.2
--- pplinux/linuxnew/drivers/mtd/cmdlinepart.c:1.1.323.1	Thu Feb  3 10:00:34 2005
+++ pplinux/linuxnew/drivers/mtd/cmdlinepart.c	Thu Feb  3 11:35:38 2005
@@ -31,6 +31,10 @@
 #include <asm/setup.h>
 #include <linux/bootmem.h>
 
+#if defined(MODULE)
+#define cmdline mtdparts
+#endif
+
 /* error message prefix */
 #define ERRP "mtd: "
 
@@ -56,7 +60,7 @@
 static struct cmdline_mtd_partition *partitions;
 
 /* the command line passed to mtdpart_setupd() */
-static char *cmdline;
+static char *cmdline = NULL;
 static int cmdline_parsed = 0;
 
 /*
@@ -335,7 +339,10 @@
 	return -EINVAL;
 }
 
-
+#if defined(MODULE)
+MODULE_PARM(mtdparts, "s");
+MODULE_PARM_DESC(mtdparts, "Partition table description");
+#else
 /* 
  * This is the handler for our kernel parameter, called from 
  * main.c::checksetup(). Note that we can not yet kmalloc() anything,
@@ -348,6 +355,7 @@
 }
 
 __setup("mtdparts=", mtdpart_setup);
+#endif
 
 EXPORT_SYMBOL(parse_cmdline_partitions);
 
Index: pplinux/linuxnew/drivers/mtd/mtdchar.c
diff -u pplinux/linuxnew/drivers/mtd/mtdchar.c:1.1.323.1 pplinux/linuxnew/drivers/mtd/mtdchar.c:1.2
--- pplinux/linuxnew/drivers/mtd/mtdchar.c:1.1.323.1	Thu Feb  3 10:00:34 2005
+++ pplinux/linuxnew/drivers/mtd/mtdchar.c	Wed Apr  6 11:53:11 2005
@@ -5,7 +5,6 @@
  * Pure 2.4 version - compatibility cruft removed to mtdchar-compat.c
  *
  */
-
 #include <linux/config.h>
 #include <linux/kernel.h>
 #include <linux/module.h>
@@ -515,8 +514,14 @@
 		kfree(databuf);
 		break;
 	}
-
-		
+#if defined(PRODUCT_FLASHX4)	
+	case MEMREADSIZE:
+	{	    	    
+	    if (copy_to_user((int *) arg, &mtd->chip_size, sizeof(int)))
+	      return -EFAULT;
+	    break;	    
+	}
+#endif	
 	default:
 		DEBUG(MTD_DEBUG_LEVEL0, "Invalid ioctl %x (MEMGETINFO = %x)\n", cmd, MEMGETINFO);
 		ret = -ENOTTY;
